# pylint: disable=C0301
"""
FFT benchmarks
----------------------------

Context
~~~~~~~~~~~~~~~~~~~~~~~~

This test runs basic numpy FFTs and IFFTs for various sizes using GPU via CuPy.
The `source code <https://gitlab.com/ska-telescope/sdp/ska-sdp-benchmark-tests/-/blob/main/apps/level0/gpu/fft_test/src/fft_numpy_ops.py>`__
can be found in the repository. The sizes of the matrices used in the test can be changed within the source code.
The four tested operations are:

- 2-Dimensional Real FFT
- 2-Dimensional Real Inverse FFT
- 2-Dimensional Complex FFT
- 2-Dimensional Complex Inverse FFT

Each of those tests runs with matrices sized 2⁵, 2⁷, 2⁹, 2¹¹ and 2¹³

Test parameterisation
~~~~~~~~~~~~~~~~~~~~~~~~

Currently, the test supports only one type of parameterisation in terms of number of threads.
Number of threads can be varied from 1 to maximum number of cores available on the System Under
Test (SUT).

Usage
~~~~~~~~~~~~~~~~~~~~~~~~

The test can be run using following commands.

.. code-block:: bash

  cd ska-sdp-benchmark-tests
  conda activate ska-sdp-benchmark-tests
  reframe/bin/reframe -C reframe_config.py -c apps/level0/gpu/fft_test/reframe_fft.py --run --performance-report


But first let's see the tests generated by ReFrame using ``--list`` command as follows:

.. code-block:: bash

  cd ska-sdp-benchmark-tests
  conda activate ska-sdp-benchmark-tests
  reframe/bin/reframe -C reframe_config.py -c apps/level0/gpu/fft_test/reframe_fft.py --list

If we want to run the run with 4 threads, we can use ``--tags`` CLI option to do so.

.. code-block:: bash

  cd ska-sdp-benchmark-tests
  conda activate ska-sdp-benchmark-tests
  reframe/bin/reframe -C reframe_config.py -c apps/level0/gpu/fft_test/reframe_fft.py --tag 4$ --run --performance-report

Test class documentation
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
"""
# pylint: enable=C0301

import reframe as rfm
import reframe.utility.sanity as sn  # pylint: disable=import-error
from modules.base_class import RunOnlyBenchmarkBase
from modules.reframe_extras import CondaSetupTest
from reframe.core.backends import getlauncher  # pylint: disable=import-error
import reframe.utility.osext as osext  # pylint: disable=import-error

from modules.utils import filter_systems_by_env
from reframe.core.builtins import fixture
import modules.conda_env_manager as cem

# pylint: disable=C0116,E0401,E0602,E1101,W0201
from reframe.core.decorators import run_after, run_before


ENV_NAME = "rfm_FftGpuTest"

@rfm.simple_test
class FftGpuTest(RunOnlyBenchmarkBase):
    """Numpy operations benchmark tests"""

    descr = 'Test real and complex FFTs and IFFTs on GPU.'
    src_setup = fixture(CondaSetupTest, scope="environment", variables={
        'env_name': ENV_NAME,
        'pip_packages': ['numpy', 'cupy']
    })

    def __init__(self):
        super().__init__()
        self.valid_prog_environs = [
            'numpy_cuda',
        ]
        self.valid_systems = filter_systems_by_env(self.valid_prog_environs)
        self.sourcepath = 'fft_numpy_ops.py'
        self.maintainers = [
            'Manuel Stutz (manuel.stutz@fhnw.ch)'
        ]
        self.time_limit = '0d1h00m0s'
        self.num_nodes = 1
        self.env_manager = cem.CondaEnvManager(ENV_NAME)

    @run_after('setup')
    def set_git_commit_tag(self):
        """Fetch git commit hash"""
        git_ref = osext.git_repo_hash(short=False, wd=self.prefix)
        self.tags |= {f'git={git_ref}'}

    @run_after('setup')
    def set_num_nodes(self):
        """Set number of nodes"""
        self.num_nodes = 1
        if self.current_partition.scheduler.registered_name == 'oar':
            self.num_tasks_per_node = \
                (self.current_partition.processor.num_cpus
                 // self.current_partition.processor.num_cpus_per_core)
        else:
            self.num_tasks_per_node = self.current_partition.processor.num_cpus
        self.num_tasks = self.num_nodes * self.num_tasks_per_node
        self.tags |= {
            'num_threads={}'.format(self.current_partition.processor.num_cpus),
        }

    @run_after('setup')
    def set_num_threads(self):
        """Set number of OpenMP threads"""
        self.variables = {
            'OMP_NUM_THREADS': str(self.current_partition.processor.num_cpus),
        }

    @run_after('setup')
    def set_launcher(self):
        """Set launcher to local"""
        self.job.launcher = getlauncher('local')()
        
    @run_after('setup')
    def emit_conda_cmds(self):
        """Emit conda env related commands in the job script"""
        self.prerun_cmds += self.env_manager.emit_conda_activate_cmds().split(';')

    @run_after('setup')
    def set_executable(self):
        """Set executable and its options"""
        self.executable = 'python3'
        self.executable_opts = ['fft_numpy_ops.py']

    @run_before('sanity')
    def set_sanity_patterns(self):
        """Set sanity patterns. Example stdout:

        .. code-block:: none

            Numpy version: 1.22.2
            Cupy version: 10.1.0
        """
        self.sanity_patterns = sn.assert_found(r'Numpy version:\s+\S+\nCupy version:\s+\S+', self.stdout)

    @performance_function('s')
    def extract_2d_real_fft_time(self, size=8192):
        """Performance extraction function for extracting time taken for 2-Dimensional Real FFT.

        Args:
            size (int): Size of the matrix for which the performance metric should be extracted.
        """
        return sn.extractsingle(
            rf'^2D FFT of a real {size:d}x{size:d} matrix in\s+(?P<fft>\S+)\s+s', self.stdout, 'fft', float
        )

    @performance_function('s')
    def extract_2d_real_ifft_time(self, size=8192):
        """Performance extraction function for extracting time taken for 2-Dimensional Real Inverse FFT.

        Args:
            size (int): Size of the matrix for which the performance metric should be extracted.
        """
        return sn.extractsingle(
            rf'^2D IFFT of a real {size:d}x{size:d} matrix in\s+(?P<ifft>\S+)\s+s', self.stdout, 'ifft', float
        )

    @performance_function('s')
    def extract_2d_complex_fft_time(self, size=8192):
        """Performance extraction function for extracting time taken for 2-Dimensional Complex FFT.

        Args:
            size (int): Size of the matrix for which the performance metric should be extracted.
        """
        return sn.extractsingle(
            rf'^2D FFT of a complex {size:d}x{size:d} matrix in\s+(?P<cfft>\S+)\s+s', self.stdout, 'cfft', float
        )

    @performance_function('s')
    def extract_2d_complex_ifft_time(self, size=8192):
        """Performance extraction function for extracting time taken for 2-Dimensional Complex Inverse FFT.

        Args:
            size (int): Size of the matrix for which the performance metric should be extracted.
        """
        return sn.extractsingle(
            rf'^2D IFFT of a complex {size:d}x{size:d} matrix in\s+(?P<cifft>\S+)\s+s', self.stdout, 'cifft', float
        )

    def extract_times_for_size(self, size):
        """Extracts the performance variables for all tests of a given matrix size.

        Args:
            size (int): Size of the matrix for which all performance metrics should be extracted.
        """
        return {
            f"{size}x{size} real fft time": self.extract_2d_real_fft_time(size),
            f"{size}x{size} real ifft time": self.extract_2d_real_ifft_time(size),
            f"{size}x{size} complex fft time": self.extract_2d_complex_fft_time(size),
            f"{size}x{size} complex ifft time": self.extract_2d_complex_ifft_time(size),
        }

    def clean_perf_variables(self):
        """
        Performance functions with arguments get added with their name and the default argument
        to the performance variables. This leads to duplicate entries. Removal is necessary.
        """
        if 'extract_2d_real_fft_time' in self.perf_variables:
            self.perf_variables.pop('extract_2d_real_fft_time')
        if 'extract_2d_real_ifft_time' in self.perf_variables:
            self.perf_variables.pop('extract_2d_real_ifft_time')
        if 'extract_2d_complex_fft_time' in self.perf_variables:
            self.perf_variables.pop('extract_2d_complex_fft_time')
        if 'extract_2d_complex_ifft_time' in self.perf_variables:
            self.perf_variables.pop('extract_2d_complex_ifft_time')

    @run_before('performance')
    def set_perf_patterns(self):
        """Set performance variables. Example stdout:

        .. code-block:: none

            2D FFT of a real 32x32 matrix in 0.000109 s.
            2D IFFT of a real 32x32 matrix in 0.000051 s.
            2D FFT of a complex 32x32 matrix in 0.000027 s.
            2D IFFT of a complex 32x32 matrix in 0.000048 s.
            # repeated for each matrix size"""
        self.clean_perf_variables()

        self.perf_variables.update({
            **self.extract_times_for_size(2**5),
            **self.extract_times_for_size(2**7),
            **self.extract_times_for_size(2**9),
            **self.extract_times_for_size(2**11),
            **self.extract_times_for_size(2**13),
        })

    @run_before('performance')
    def set_reference_values(self):
        """Set reference performance values."""
        self.reference = {
            '*': {
                '*': (None, None, None, 's'),
            },
        }
